#include "stm32l1xx_hal.h"
#include "tsl_user.h"
#include "stm32l152c_discovery_glass_lcd.h"

#define DATA_EEPROM_START_ADDR     0x08080000
#define DAK_Scale 22            //     
#define DAK_ADC_A0 352          //     
#define DAK_ADC_A90 2332        //     
#define LED_GREEN_ON {HAL_GPIO_WritePin(LD3_GPIO_Port, LD3_Pin, GPIO_PIN_SET);}
#define LED_GREEN_OFF {HAL_GPIO_WritePin(LD3_GPIO_Port, LD3_Pin, GPIO_PIN_RESET);}

extern DAC_HandleTypeDef hdac;
extern uint32_t process_sensor;
extern uint32_t process_sensor_back, Step_DRV_Enable, Step_Dir, Start_Touch, TSL_asq_count;
extern uint32_t flag_button, release_button, flag_menu;
extern uint16_t ADC_Result, ADC_A0, ADC_A90; //     ADC
extern unsigned char strDisp[6]; //     
extern uint32_t Sys_ms, Back_ms;
extern uint8_t Speed, Pause, DRV_current, A_0, A_140, Scale, A_Min, A_Max, LCDBar; 

extern void ADC_Conv(void);
extern void ADC_Conv_Disp(void);
extern void EE_Save(uint32_t Address, uint8_t Data);
extern void convert_into_char(uint16_t number, unsigned char *p_tab);
void LCD_Display_Str_Col(uint8_t Column);
void Calibr(void);

/****************************************/
void Menu()
{
 	tsl_user_status_t tsl_status;
	uint32_t flag_ADC_A0, flag_ADC_A90, error=0, changes=0;
	uint8_t Menu_Item, Sens_Value, Blank=0;
  
  Menu_Item=0;
  Step_DRV_Enable = 0; //     
  Back_ms=Sys_ms;
	BSP_LCD_GLASS_Clear();
	strDisp[0]='M';
  strDisp[1]='E';
  strDisp[2]='N';
  strDisp[3]='U';
  strDisp[4]=' ';
  strDisp[5]=' ';
	LCD_Display_Str_Col(0);
  while ((B1_GPIO_Port->IDR & B1_Pin)) ; //   
  flag_menu = 1;
  flag_button=0;
  release_button=0;
  while (flag_menu == 1)
  {
    /*************   ****************/
    // Execute STMTouch Driver state machine
    if (process_sensor_back != process_sensor) //     
      if (!process_sensor) //    , ..  
      {
      Start_Touch=1; //    
      TSL_asq_count=5; // -    TSL    
      } 
    process_sensor_back = process_sensor; //    
		tsl_status = tsl_user_Exec();
		if ((tsl_status != TSL_USER_STATUS_BUSY) && process_sensor)
      Sens_Value = MyLinRots[0].p_Data->Position; 
    /********   **********/
    if ((B1_GPIO_Port->IDR & B1_Pin)) //   
    {
      flag_button=1;
      HAL_Delay(10);
      LED_GREEN_ON;
      if ((Sys_ms - Back_ms) >= 2000) // 2 sec. Sys_ms   1ms
        flag_menu=0;
    }
    else
    {
      Back_ms=Sys_ms;
    }
    if ((flag_button==1)&&!(B1_GPIO_Port->IDR & B1_Pin)) //   
    {
      LED_GREEN_OFF;
      flag_button=0;
      release_button=1;
    }
    /******   ****************/
    if (flag_menu == 1)
    {      
      if (Menu_Item == 0) //********* /  *************
      {
        if (release_button)
        {
          Menu_Item++;
          release_button=0;
        }
        else
        {
          if (process_sensor)
          {
            Pause = Sens_Value / 13;
            Blank ^= 1;
						changes = 1;
					}
					else
					{
						Blank = 0;
					}
          convert_into_char(Pause+A_0, strDisp);
          strDisp[0]='';
          strDisp[1]='A';
          strDisp[2]='';
          strDisp[3]='3';
					if (Blank)
						strDisp[5]=' ';
					else
						strDisp[5]=strDisp[4];
					strDisp[4]=' ';
					LCD_Display_Str_Col(4);
        }
      }
      else if (Menu_Item == 1) //********* / MAX  *************
      {
        if (release_button)
        {
          Menu_Item++;
          release_button=0;
        }
        else
        {
          if (process_sensor)
          {
            Blank ^= 1;
            Speed = 2 + Sens_Value / 16;
						changes = 1;
          }
					else
					{
						Blank = 0;
					}
          convert_into_char(Speed+A_0, strDisp);
          strDisp[0]='C';
          strDisp[1]='K';
          strDisp[2]='O';
          strDisp[3]='P';
					if (Blank)
						strDisp[5]=' ';
					else
						strDisp[5]=strDisp[4];
					strDisp[4]=' ';
					LCD_Display_Str_Col(4);
        }
      }
      else if (Menu_Item == 2) //********* /   *************
      {
        if (release_button)
        {
          Menu_Item++;
					if (changes == 0)
						Menu_Item++;
          release_button=0;
        }
        else
        {
          if (process_sensor)
          {
            DRV_current = 1 + Sens_Value / 15;
						HAL_DAC_SetValue(&hdac, DAC_CHANNEL_1, DAC_ALIGN_12B_R,(uint32_t)(1023 + DRV_current * 341));
            Blank ^= 1;
						changes = 1;
					}
					else
					{
						Blank = 0;
					}
          convert_into_char(DRV_current+A_0, strDisp);
          strDisp[0]='C';
          strDisp[1]='';
          strDisp[2]='';
          strDisp[3]='A';
					if (Blank)
						strDisp[5]=' ';
					else
						strDisp[5]=strDisp[4];
					strDisp[4]=' ';
					LCD_Display_Str_Col(4);
        }
      }
      else if (Menu_Item == 3) //*********   ( ) *************
      {
        if (release_button)
        {
          Menu_Item++;
          release_button=0;
        }
        else
        {
          if (process_sensor)
          {
            Blank ^= 1;
            if (Blank)
              strDisp[5]=' ';
            else
              strDisp[5]='Y';
          }
          else if (process_sensor_back == 1) //     
          {
						Blank = 0;
            EE_Save(DATA_EEPROM_START_ADDR+0,222);
            EE_Save(DATA_EEPROM_START_ADDR+1,Pause);
            EE_Save(DATA_EEPROM_START_ADDR+2,Speed);
            EE_Save(DATA_EEPROM_START_ADDR+3,Scale);
            EE_Save(DATA_EEPROM_START_ADDR+4,A_0);
						EE_Save(DATA_EEPROM_START_ADDR+5,DRV_current);
            Menu_Item++;
						changes = 0;
          }
          else
          {
            strDisp[0]='C';
            strDisp[1]='O';
            strDisp[2]='X';
            strDisp[3]='P';
            strDisp[4]=' ';
            strDisp[5]='_';
          }
					LCD_Display_Str_Col(4);
        }
      }
      else if (Menu_Item == 4) //*********    *************
      {
        if (release_button)
        {
          Menu_Item++;
          release_button=0;
        }
        else
        {
          if (process_sensor)
          {
            Blank ^= 1;
            if (Blank)
              strDisp[5]=' ';
            else
              strDisp[5]='Y';
          }
          else if (process_sensor_back == 1) //     
          {
            flag_menu = 0;
          }
          else
          {
            strDisp[0]='B';
            strDisp[1]='';
            strDisp[2]='X';
            strDisp[3]='O';
            strDisp[4]='';
            strDisp[5]='_';
          }
					LCD_Display_Str_Col(0);
        }
      }
      else if (Menu_Item == 5) //*********    *************
      {
        if (release_button)
        {
          Menu_Item = 0;
          release_button=0;
        }
        else
        {
          if (process_sensor)
          {
            Blank ^= 1;
            if (Blank)
              strDisp[5]=' ';
            else
              strDisp[5]='Y';
          }
          else if (process_sensor_back == 1) //     
          {
						Blank = 0;
            Menu_Item++;
            ADC_A0 = DAK_ADC_A0; //     
            ADC_A90 = DAK_ADC_A90; //     
            flag_ADC_A0 = flag_ADC_A90 = error = 0;
          }
          else
          {
            strDisp[0]='K';
            strDisp[1]='';
            strDisp[2]='6';
            strDisp[3]='P';
            strDisp[4]=' ';
            strDisp[5]='_';
          }
					LCD_Display_Str_Col(4);
        }
      }
      else if (Menu_Item == 6) //*********  0 *************
      {
        if (release_button)
        {
          Menu_Item++;
          release_button=0;
        }
        else
        {
          strDisp[3]=' ';
          strDisp[4]='0';
          strDisp[5]='';
          if (process_sensor)
          {
            Blank ^= 1;
            Calibr();
            ADC_A0=ADC_Result;
            flag_ADC_A0 = 1;
            if (Blank)
            {
              strDisp[3]=' ';
              strDisp[4]=' ';
              strDisp[5]=' ';
            }
          }
          else
          {
						Blank = 0;
            Step_DRV_Enable = 0; //     
          }
          strDisp[0]='';
          strDisp[1]='C';
          strDisp[2]='T';
					LCD_Display_Str_Col(3);
					LCDBar = 0;
        }
      }
      else if (Menu_Item == 7) //*********  90 *************
      {
        if (release_button)
        {
          Menu_Item++;
          release_button=0;
        }
        else
        {
          strDisp[3]='9';
          strDisp[4]='0';
          strDisp[5]='';
          if (process_sensor)
          {
            Blank ^= 1;
            Calibr();
            ADC_A90=ADC_Result;
            flag_ADC_A90 = 1;
            if (Blank)
            {
              strDisp[3]=' ';
              strDisp[4]=' ';
              strDisp[5]=' ';
            }
          }
          else
          {
						Blank = 0;
            Step_DRV_Enable = 0; //     
          }
          strDisp[0]='';
          strDisp[1]='C';
          strDisp[2]='T';
					LCD_Display_Str_Col(3);
					LCDBar = 0;
        }
      }
      else if (Menu_Item == 8) //*********     (. Scale) *************
      {
        if (release_button)
        {
          release_button=0;
          if (error)
          {
            Menu_Item=5;
            Scale=DAK_Scale; //     
          }
          else
            Menu_Item=3;
        }
        else
        {
          if (flag_ADC_A0 && flag_ADC_A90)
          {
            Scale = (ADC_A90 - ADC_A0)/90;
            if ((ADC_A90 - ADC_A0)%90 >= 5)
              Scale++;
            if ((Scale <= 99)&&(Scale >= 5))
            {
              convert_into_char(Scale+A_0, strDisp);
              strDisp[5]=strDisp[4];
              strDisp[4]=strDisp[3];
              strDisp[0]='M';
              strDisp[1]='A';
              strDisp[2]='C';
              strDisp[3]='';
              A_0 = A_Min = ADC_A0/Scale;
              A_140 = A_Max = A_0+140;
            }
            else
            {
              strDisp[0]='O';
              strDisp[1]='';
              strDisp[2]='';
              strDisp[3]='6';
              strDisp[4]='K';
              strDisp[5]='A';
              error = 1; //   
            }              
					LCD_Display_Str_Col(4);
          }
          else
            Menu_Item = 0;
        }
      }
      else
      {
        Menu_Item = 0;
      }
    }
  }
  Back_ms=Sys_ms;
  ADC_Conv_Disp();
  while ((B1_GPIO_Port->IDR & B1_Pin)) ; //   
  flag_button=0;
  error = 0;
}
/********************************************************************/
void Calibr()
{
  ADC_Conv();
  ADC_Result = (4096-ADC_Result); //  .. .      
  if (Start_Touch)
  { 
    if (TSL_asq_count == 0)
    {
      if (MyLinRots[0].p_Data->Position >= 100)
      {
        Step_Dir = 0;
				Step_DRV_Enable = 1; //      
      }
      if (MyLinRots[0].p_Data->Position <= 20)
      {
        Step_Dir = 1;
				Step_DRV_Enable = 1; //      
      }
      Start_Touch=0;
    }
    else
    {
      TSL_asq_count--;
			return;
    }
  }
  if (Step_Dir == 1)
  {
    TIM6->ARR = 100 - 0.76*(MyLinRots[0].p_Data->Position);
    if (MyLinRots[0].p_Data->Position >= 2)    LCDBar = 1;
    if (MyLinRots[0].p_Data->Position >= 32)   LCDBar = 2;
    if (MyLinRots[0].p_Data->Position >= 64)   LCDBar = 3;
    if (MyLinRots[0].p_Data->Position >= 96)   LCDBar = 4;
  }
  else
  {
    TIM6->ARR = 100 - 0.76*(127 - MyLinRots[0].p_Data->Position);
    if (MyLinRots[0].p_Data->Position <= 120)  LCDBar = 1;
    if (MyLinRots[0].p_Data->Position <= 96)   LCDBar = 2;
    if (MyLinRots[0].p_Data->Position <= 64)   LCDBar = 3;
    if (MyLinRots[0].p_Data->Position <= 32)   LCDBar = 4;
  }  
}

/*********************************************************/
void LCD_Display_Str_Col(uint8_t Column)
{
	BSP_LCD_GLASS_WriteChar(strDisp+0, POINT_OFF, DOUBLEPOINT_OFF, LCD_DIGIT_POSITION_1);
	BSP_LCD_GLASS_WriteChar(strDisp+1, POINT_OFF, DOUBLEPOINT_OFF, LCD_DIGIT_POSITION_2);
	if (Column==3)
		BSP_LCD_GLASS_WriteChar(strDisp+2, POINT_OFF, DOUBLEPOINT_ON, LCD_DIGIT_POSITION_3);
	else
		BSP_LCD_GLASS_WriteChar(strDisp+2, POINT_OFF, DOUBLEPOINT_OFF, LCD_DIGIT_POSITION_3);
	if (Column==4)
		BSP_LCD_GLASS_WriteChar(strDisp+3, POINT_OFF, DOUBLEPOINT_ON, LCD_DIGIT_POSITION_4);
	else
		BSP_LCD_GLASS_WriteChar(strDisp+3, POINT_OFF, DOUBLEPOINT_OFF, LCD_DIGIT_POSITION_4);
	BSP_LCD_GLASS_WriteChar(strDisp+4, POINT_OFF, DOUBLEPOINT_OFF, LCD_DIGIT_POSITION_5);
	BSP_LCD_GLASS_WriteChar(strDisp+5, POINT_OFF, DOUBLEPOINT_OFF, LCD_DIGIT_POSITION_6);
}
